awol = {
	{
		coords = {20,20,300,400},
		theme = {10,20,130},
		header = "Test table",
		settings = {
			minimisable = true,
			removable = true,
			resizable = true,
		},
		minimised = false
	},
}

function awolDraw()
	for i = 1,#awol do
		awolWindow(awol[i])
	end
end

function awolWindow(table)
	local x = table.coords[1]
	local y = table.coords[2]
	local width = table.coords[3]
	local height = table.coords[4]
	local theme = table.theme
	local header = table.header
	local settings = table.settings
	local minimised = table.minimised
	
	if not minimised then
		love.graphics.setColor(20,20,20)
		love.graphics.rectangle("fill",x,y,width,height)
	end
	love.graphics.setColor(theme[1],theme[2],theme[3])
	love.graphics.polygon("fill",x+5,y-10,x+width-5,y-10,x+width,y-5,x+width,y,x,y,x,y-5)
	love.graphics.setColor(theme[1]+10,theme[2]+10,theme[3]+10)
	love.graphics.polygon("line",x+5,y-10,x+width-5,y-10,x+width,y-5,x+width,y,x,y,x,y-5)
	if not minimised then
		love.graphics.rectangle("line",x,y,width,height)
	end
	
	love.graphics.setColor(255,255,255)
	love.graphics.print(header,x+5,y-10)
	if settings.minimisable then
		love.graphics.print("~",x+width-25,y-10)
	end
	if settings.removable then
		love.graphics.print("X",x+width-10,y-10)
	end
	if settings.resizable and not minimised then
		love.graphics.setColor(theme[1]+10,theme[2]+10,theme[3]+10)
		love.graphics.polygon("fill",x+width,y+height-10,x+width,y+height,x+width-10,y+height)
		love.graphics.setColor(255,255,255)
		love.graphics.print(".",x+width-4,y+height-14)
	end
	love.graphics.setColor(255,255,255)
end

awolI = {
	window = 0,
	pos = {},
	offset = {},
}

function love.mousepressed(x,y,button)
	if button == "l" then
		if awolMouseCollider(x,y) ~= null then
			awolI.window = awolMouseCollider(x,y)
			awolI.pos = {awol[awolI.window].coords[1],awol[awolI.window].coords[2]}
			awolI.offset = {x-awolI.pos[1],y-awolI.pos[2]}
			if checkCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-25,awolI.pos[2]-10,25,10) then
				if checkCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-25,awolI.pos[2]-10,10,10) then
					if not awol[awolI.window].minimised then
						awol[awolI.window].minimised = true
					else
						awol[awolI.window].minimised = false
					end
				elseif checkCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-10,awolI.pos[2]-10,10,10) then
					table.remove(awol,awolI.window)
				end
				awolI = {
					window = 0,
					pos = {},
					offset = {},
				}
			end
		end
	end
	if button == "r" then
		mouseAction(x,y,2)
	end
	if button == "wu" then
		mouseAction(x,y,3)
	end
	if button == "wd" then
		mouseAction(x,y,4)
	end
	if button == "m" then
		mouseAction(x,y)
	end
end

function awolMouseCollider(x,y)
	local current = null
	for i,v in ipairs(awol) do
		if checkCollision(x,y,1,1,v.coords[1],v.coords[2]-10,v.coords[3],10) == true then
			current = i
		end
	end
	return current
end

function awolInput(dt)
	local x,y = love.mouse.getX(),love.mouse.getY()
	local awolMC_result = awolMouseCollider(x,y)
	
	if love.mouse.isDown("l") then
		if awolI.window ~= 0 then
			awol[awolI.window].coords[1] = x - awolI.offset[1]
			awol[awolI.window].coords[2] = y - awolI.offset[2]
		end
	elseif not love.mouse.isDown("l") then
		awolI = {
			window = 0,
			pos = {},
			offset = {},
		}
	end
end

